#ifndef FILEPLATFORM_H_
#define FILEPLATFORM_H_ 1
#ifdef __cplusplus
 extern "C" {
#endif 
#include <stdint.h>
#include "Errors.h"

/** File Options - high level file routines, based on PetiteFatFs, which can
 * only open one read-only file at a time **/

void FileInit();

/** Opens file or returns exception **/
/** Returns File Exception on failure **/
void FileOpenRO(const char *fname);
void FileClose();

/** Throws exception on error **/
int FileRead(char *buf, uint32_t len);
void FileSeek(uint32_t pos);
char FileGetC();

#ifdef __cplusplus
}
#endif 
#endif //FILEPLATFORM_H_
