#include <iostream>

#ifndef PROGMEM
#  define PROGMEM
#endif
#include "Platform.h"
#include "Glyphs.h"
#include "Errors.h"

#if 0
#include "data/fonts_8x8_2.pic.inc"
#else
#include "data/iso8859-1.c"
#endif

#include <stdlib.h>

int main(int argc, char **argv) {
  PlatformInit();
  if (IsError) {
    std::cerr << "EXCEPTION: " << errorMsg << "\n";
  }
#if 0
  uint8_t font_bitpacked[FONT_TILESET_SIZE*8];
  printf("FOO %i\n", FONT_TILESET_SIZE);
  for (int i=0; i<FONT_TILESET_SIZE; ++i) {
    uint8_t b=0x0;
    for (int j=0; j<8; ++j) {
      for (int k=0; k<8; ++k) {
        b = (b << 1) | 0x1 & ((!!font_tileset2[8*8*i + 8*j + k]));
      }
      font_bitpacked[8*i + j] = b;
      unsigned char b2=b;
      for (int k=0; k<8; ++k) {
        printf((b2 & 0x1) ? "%i" : " ", (b2 & 0x1));
        b2 >>= 1;
      }
      printf("  = Glyph # %i\n", i);
    }
    printf("\n");
    printf("\n");
  }

  for (int i=0; i<FONT_TILESET_SIZE; ++i) {
    for (int j=0; j<8; ++j) {
      unsigned char b2=font_bitpacked[8*i + j];
      for (int k=7; k>=0; --k) {
        unsigned char v = (b2 >> k) & 0x1;
        printf(v ? "%i" : " ", v);
      }
      printf("  = BitGlyph # %i\n", i);
    }
    printf("\n");
  }
#endif
  SetGlyphMap((const uint8_t*) font_bitpacked, FONT_TILESET_SIZE, 8, 16);
  ClearCells();
  ScrClear();

#if 0
  {
    const char *s="HELLO WORLD";
    for (int j=0; j<10; ++j) {
      try {
        AddGlyph(0, 8*j, 'A' + j - ' ');
        for (int i=0; s[i] != 0x0; ++i) {
          AddGlyph( 10 + (8+j)*i, (10+j)*j, s[i] - ' ');
        }
      } catch (PlaceCellException const& e) {
        std::cerr << "PlaceCellException\n";
        DebugPrintGlyphs();
        sleep(1);
      }
    }
  }
#else
  {
    const char *s="HELLO WORLD";
    for (int j=0; j<10; ++j) {
      do {
        AddGlyph(0, 8*j, 'A' + j, 1, 0);
        if (IsError) break;
        for (int i=0; s[i] != 0x0; ++i) {
          AddGlyph( 10 + (8+j)*i, (10+j)*j, s[i], 1, 0);
          if (IsError) break;
        }
      } while(0);
      if (IsError) {
        std::cerr << "PlaceCellException\n";
        DebugPrintGlyphs();
        ClearError();
        sleep(1);
      }
    }
  }
#endif
  VideoUpdate();
  DebugPrintGlyphs();
  sleep(1);
  { // scroll
    for (int i=0; i<100; ++i) {
      cellMapXOffset += 1;
      VideoUpdate();
    }
    for (int i=0; i<100; ++i) {
      cellMapYOffset += 1;
      VideoUpdate();
    }
    for (int i=0; i<100; ++i) {
      cellMapYOffset += 1;
      cellMapXOffset += 1;
      VideoUpdate();
    }
  }

  {
    Cell c;
    c.glyphIndex=45;
    unsigned char buf[RenderBufferSize()];
    for (int i=0; i < RenderBufferSize(); ++i) buf[i] = 0x0;
    RenderCell8bpp(c, buf, 0, 0);
    for (int i=0; i < 16; ++i) {
      for (int j=0; j < 16; ++j) {
        unsigned char ch = buf[i*RenderBufferWidth() + j];
        printf(ch ? "%2x" : "..", ch);
      }
      printf("\n RENDER BUFFER OUTPUT");
    }
  }

  for (int i=0; i<255; ++i) {
    int x = ((glyphWidth + 2)*i) % PIXEL_WIDTH;
    int y =  (glyphHeight + 2)*((((glyphWidth + 2)*i)/PIXEL_WIDTH) % PIXEL_HEIGHT);
    int c = i % FONT_TILESET_SIZE;
    AddGlyph( x, y, c, 1, 0);
    if (IsError) {
      std::cerr << "PlaceCellException cycle " << i << "\n";
      ClearCells();
      ScrClear();
      ClearError();
    }
    VideoUpdate();
    usleep(1000);
  }
  DebugPrintGlyphs();
  return 0;
}
