#include "Terminal.h"
#include "Platform.h"
#include "VideoUzeAsm.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/power.h>

#if 0
#include "data/fonts_8x8_2.pic.inc"
#else
#include "data/iso8859-1.c"
#endif

void VideoInit() { 
  // DEBUG: SLOW DOWN TIME 14.3 MHz
  //clock_prescale_set(1);

	//stop timers
	TCCR1B=0;

  //  16-BIT TIMER 1 HANDLING VIDEO INTERRUPTS
  /*
   *    * Run timer 1 in CTC mode, prescaler 64.
   *       */
  TCCR1B = _BV(WGM12) | _BV(CS10);
  //TCCR1B = _BV(WGM12) | _BV(CS12)| _BV(CS10);
  OCR1A = 0;
  /*
   *    * Compare match 1A interrupts.
   *       */
  TIMSK1 |= _BV(OCIE1A);

  OCR1A = (1 << 14); // the interrupt will hit this soon enough

#if 0  
	//set ports
	DDRC=0xff; //video dac
	DDRB=0xff; //h-sync for ad725
  //set clock divider counter for AD725 on TIMER0
	//outputs 14.31818Mhz (4FSC)
	TCCR0A=(1<<COM0A0)+(1<<WGM01); //toggle on compare match + CTC
	OCR0A=0; //divide main clock by 2
	TCCR0B=(1<<CS00); //enable timer, no pre-scaler

	SYNC_PORT=(1<<SYNC_PIN)|(1<<VIDEOCE_PIN); //set sync & chip enable line to hi
#endif

  sei();

}

void VideoUpdate() { }


