#include "Blitter.h"

Raster rasterList[RasterListLen];
BlitterMachine blitter;

void BlitSetup() {
  blit.cycle = 0;
  blit.pA = blit.reg[0].p;
  blit.pB = blit.reg[1].p;
  blit.pC = blit.reg[2].p;
  blit.pD = blit.reg[3].p;
  blit.cyclesLeft = blit.w * blit.h;
}

void BlitExec(int phase) {
  /* Calculate pointers */
  ++blit.pA;
  ++blit.pB;
  ++blit.pD;
  /* Fetch values A, B, C */
  unsigned char vA,vB;
  vA = *blit.pA;
  vB = *blit.pB;
  /* Rotate values A and B */
  vA = (vA >> blit.shift[0]) | (vA << 7);
  vB = (vB >> blit.shift[1]) | (vB << 7);
  /* Truthtable Op - Not implemented.  B is always a mask,
   * blit always overlays */
  /* assign result */
  *blit.pD = ((*blit.pD) & ~vB) | vA;
  --blit.cyclesLeft;
}
