#ifndef DELAYFIX_H_
#define DELAYFIX_H_ 1

void delay_cycles(uint16_t count);
void delay_ms_asm(uint16_t msec);

inline void my_delay_loop_2(uint16_t __count)
{
#if 1
  delay_cycles(__count);
#else
  //for (int i=0; i< (__count); ++i);
	__asm__ volatile (
      "nop\n\t"
		"1: sbiw %0,1" "\n\t"
		"brne 1b"
		: "=w" (__count)
		: "0" (__count)
	);
#endif
}

inline void my_delay_ms(double __ms) {
	uint16_t __ticks;
	double __tmp = ((F_CPU) / 4e3) * __ms;
	if (__tmp < 1.0)
		__ticks = 1;
	else if (__tmp > 65535)
	{
		//	__ticks = requested delay in 1/10 ms
		__ticks = (uint16_t) (__ms * 10.0);
		while(__ticks)
		{
			// wait 1/10 ms
			my_delay_loop_2(((F_CPU) / 4e3) / 10);
			__ticks --;
		}
		return;
	}
	else
		__ticks = (uint16_t)__tmp;
	my_delay_loop_2(__ticks);
}


#endif // DELAYFIX_H_
