
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>  
#include <avr/sleep.h>

#include "z813-defines.h"

void tapStringAsm(const char *s);

void sounder(int onOrOff, int msec) {
  DDRD  |= 1 << PD4;
  if (onOrOff)
    PORTD &= ~(1 << PD4); // led on
  else 
    PORTD |= 1 << PD4; // led off
  _delay_ms((float)msec);
  PORTD |= 1 << PD4; // off at end
}

  extern unsigned char burstOffset;
	extern unsigned char curr_frame;
	extern unsigned char vsync_phase;

void init() {
	//stop timers
	TCCR1B=0;

	//set ports
	DDRC=0xff; //video dac
	DDRB=0xff; //h-sync for ad725
	SYNC_PORT=(1<<SYNC_PIN)|(1<<VIDEOCE_PIN); //set sync & chip enable line to hi

  //  16-BIT TIMER 1 HANDLING VIDEO INTERRUPTS
#if 1
  /*
   *    * Run timer 1 in CTC mode, prescaler 64.
   *       */
  TCCR1B = _BV(WGM12) | _BV(CS10);
  //TCCR1B = _BV(WGM12) | _BV(CS12)| _BV(CS10);
  OCR1A = 0;
  /*
   *    * Compare match 1A interrupts.
   *       */
  TIMSK1 |= _BV(OCIE1A);

  OCR1A = (1 << 14); // the interrupt will hit this soon enough
#endif
	
  //set clock divider counter for AD725 on TIMER0
	//outputs 14.31818Mhz (4FSC)
	TCCR0A=(1<<COM0A0)+(1<<WGM01); //toggle on compare match + CTC
	OCR0A=0; //divide main clock by 2
	TCCR0B=(1<<CS00); //enable timer, no pre-scaler

	SYNC_PORT=(1<<SYNC_PIN)|(1<<VIDEOCE_PIN); //set sync & chip enable line to hi
  sei();

}

int main() {
  //tapString("S ");
  init();
  //while (1)
    //test_delay();
  //while (1)
   // run_timetable();
  for (int i=0; 1; ++i) {
    char c[2];
    c[1] = (i % 42) + '0';
    c[2] = 0x0;
//    tapString(c);
//    tapString("          ");
  }
}
