#include <stdint.h>
#include "../uCmorse/uCmorse.h"
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/sleep.h>
#include <util/delay.h>

//define F_CPU 1000000ul

uint8_t clk;

void sounder(int onOrOff, int msec) {
  DDRD  |= 1 << PD4;
  if (onOrOff)
    PORTD &= ~(1 << PD4); // led on
  else 
    PORTD |= 1 << PD4; // led off
  _delay_ms((float)msec);
  PORTD |= 1 << PD4; // off at end
}

ISR(TIMER1_COMPA_vect)
{
  PIND = 0x1 << PD4;
  PINA = 0x1 << PA3;
  uint8_t xl = OCR1AL;
  uint8_t xh = OCR1AH;
  TCNT1 = 0;
  //xh += 0x10;
  //xh &= 0xf0;
  xh += 0x01;
  xh &= 0x0f;
  if (!xh) {
    PINA = 0x1 << PA1;
    xh = 0x01; // we don't want zero == 65k
  }
  OCR1AH = xh;
  OCR1AL = xl;
}

//ISR(TIMER1_COMPA_vect)
void realISR()
{
  clk++;
  uint16_t t = TCNT1;
  PORTD = (clk & 0x1) << PD4;
  PORTA = (clk & 0x1) << PA3;
  if (clk & 0x1)
    OCR1A = 1*F_CPU / 1024;
  else
    OCR1A = 2*F_CPU / 1024;
  //if (t < 1000)
  //  tapChar('0' + t/100);
  //else
  //  tapChar('X');

}

  void
ioinit(void)
{
  DDRD = 0xFF;
  DDRA |= 0x1 << PA3;
  /*
   *    * Run timer 1 in CTC mode, prescaler 64.
   *       */
  //TCCR1B = _BV(WGM12) | _BV(CS11) | _BV(CS10);
  // pre-scale 1024
  //TCCR1B = _BV(WGM12) | _BV(CS12)| _BV(CS10);
  // pre-scale 1
  TCCR1B = _BV(WGM12) | _BV(CS10);
  /*
   *    * Compare match after one second.
   *       */
  //OCR1A = 2*F_CPU / 1024;
  OCR1A = 0x1000;
  /*
   *    * Compare match 1A interrupts.
   *       */
  TIMSK1 |= _BV(OCIE1A);
  sei();
}

  int
main(void)
{
  ioinit();

  for (;;)
    sleep_mode();

  return 0;
} 
